#!/usr/bin/perl
#
# LightSquid Project (c) 2004-2005 Sergey Erokhin aka ESL
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# detail see in gnugpl.txt

print "Content-Type: text/html\n\n";

use File::Basename;
push (@INC,(fileparse($0))[1]);

use CGI;
require "lightsquid.cfg";
require "common.pl";

InitTPL("whousesite");

$co=new CGI;

$mode="day";

$year       =$co->param('year');
$month      =$co->param('month');
$day        =$co->param('day');
$usersite   =$co->param('usersite');

$mode =$co->param('mode');

if      ($mode eq "month") {
  $workperiod="##MSG_WHOLE## ##MSG_MONTH## - $year $MonthName[$month]";
  $mask = "$year$month*";
} elsif ($mode eq "year") {
  $workperiod="##MSG_WHOLE## ##MSG_YEAR## - $year";
  $mask = "$year*";
} else {
  $mode="day";
  $workperiod="$day $MonthName[$month] $year";
  $mask = "$year$month$day";
}
	      


#@days=sort glob("$reportpath/$year$month$day/*");
@days=sort glob("$reportpath/$mask/*");
@days=reverse @days;

foreach $userpath (@days) {
   next if ($userpath =~ m/\.total/);

   $userpath =~ m/\/(\d*)\/(.*)$/;
   $user=$2;
   $date=$1;

   open FF,"<$userpath";
    $totalsize=<FF>;chomp $totalsize;$totalsize=~s/total: //;
    while (<FF>) {
      ($site,$size,$hit)=split;
      next unless ($site eq $usersite);
      $hash{$user}+=$size;
      $hhit{$user}+=$hit;
      $hday{$user}{$date}=1;
      $total   +=$size;
      $hittotal+=$hit;
    }
   close FF;
}


$N=0;
foreach $user (sort {$hash{$b} <=> $hash{$a}} keys %hash) {
  $printsize   =FineDec($hash{$user});
  $printconnect=FineDec($hhit{$user});
  
  $usedaylist="";
  if ($mode ne "day") {
    foreach $date (sort keys %{$hday{$user}} ) {
      $date =~ m/(\d\d\d\d)(\d\d)(\d\d)/;
      $usedaylist .= qq(<a href="user_detail.cgi?year=$1&month=$2&day=$3&user=$user">).GetTxtDate($date)."</a><br>";
    }
  }

  $tmp=$hTPL{who};
  $tmp=~s/##WHOUSER##/$user/;
  $tmp=~s/##WHOCONNECT##/$printconnect/;
  $tmp=~s/##WHOSIZE##/$printsize/;
  $tmp=~s/##USEDAYS##/$usedaylist/;
  $tpl{who} .= $tmp;
	      
}
close FF;

$totalprint=FineDec($total);
$totalhitprint=FineDec($hittotal);

ReplaceTPL(TOTAL,$totalprint);
ReplaceTPL(TOTALCONNECT,$totalhitprint);
ReplaceTPL(SITE,$usersite);
ReplaceTPL(DATE,$workperiod);
	      
ApplyTPL();
print $template

__END__
2005-05-01 ADD : month & year mode support
           ADD : if mode (month or year) add cell with dates -> user_detail
	   