#!/usr/bin/perl
#
# LightSquid Project (c) 2004-2005 Sergey Erokhin aka ESL
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# detail see in gnugpl.txt


print "Content-Type: text/html\n\n";

use File::Basename;
push (@INC,(fileparse($0))[1]);

use CGI;
require "lightsquid.cfg";
require "common.pl";

InitTPL("bigfiles");

$co=new CGI;

$year        =$co->param('year');
$month       =$co->param('month');
$day         =$co->param('day');

$n=1;

$workperiod=" $day $MonthName[$month] $year";

open FF,"<$reportpath/$year$month$day/.bigfiles" || die "cant' open .bigfile";

$N=0;
while (<FF>) {
 $N++;
 ($user,$time,$size,$link)=split;
 $printsize=FineDec($size);

 $tmp=$hTPL{bigfile};
 $tmp=~s/##BFILENUM##/$N/;
 $tmp=~s/##BFILETIME##/$time/;
 $tmp=~s/##BFILEUSER##/$user/;
 $tmp=~s/##BFILESIZE##/$printsize/;
 $tmp=~s/##BFILELINK##/$link/;
 $tpl{bigfile} .= $tmp;
}

close FF;

ReplaceTPL(DATE,$workperiod);
		
ApplyTPL();
print $template;

__END__
2004-09-09 ADD : skip all files starting with .
2005-04-17 ADD : TemplateEngine
