#!/usr/bin/perl
#
# LightSquid Project (c) 2004-2005 Sergey Erokhin aka ESL
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# detail see in gnugpl.txt

print "Content-Type: text/html\n\n";

use File::Basename;
push (@INC,(fileparse($0))[1]);

use CGI;
require "lightsquid.cfg";
require "common.pl";

InitTPL("day_detail");

$co=new CGI;

#$year ="2004";
#$month="05";
#$day  ="01";
#$user ="#169";

$year      =$co->param('year');
$month     =$co->param('month');
$day       =$co->param('day');
$oversize  =$co->param('oversize');

$daypath="$reportpath/$year$month$day";

$workperiod="$day $MonthName[$month] $year";

($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat("$daypath");
($sec_,$min_,$hour_,$mday_,$mon_,$year_,$wday_,$yday_,$isdst_)=localtime($mtime);
$mon_++;$year_+=1900;
$workperiod .= " (##MSG_UPDATE## :: ".sprintf("%02d:%02d",$hour_,$min_)." ::  $mday_ $MonthName[$mon_] $year_)";

$topsitesurl="topsites.cgi?year=$year&month=$month&day=$day";
$bigfilesurl="bigfiles.cgi?year=$year&month=$month&day=$day";

open FF,"<$daypath/.total";
$totaluser=<FF>;chomp $totaluser;$totaluser=~s/^user: //;
$totalsize=<FF>;chomp $totalsize;$totalsize=~s/^size: //;

$totalsize=1 if ($totalsize == 0);

$topsites=qq(<A href="$topsitesurl">##MSG_TOP_SITES##</A>);
$bigfiles=qq(BIG files);
if (-f "$daypath/.bigfiles") {
 $bigfiles=qq(<A href="$bigfilesurl">##MSG_BIG_FILES##</A>);
}

if ($oversize) {
 $overmsg="##MSG_OVERSIZE_HEAD## ".FineDec($perusertrafficlimit)." ##MSG_OVERSIZE_TAIL##";
}

$N=0;
while (<FF>) {
  
  $N++;
  ($user,$size,$hit)=split;


  next if ($oversize && ($size < $perusertrafficlimit));

  $percent  =sprintf("%2.1f",int($size*1000/$totalsize)/10);
  $printhit =FineDec($hit);
  $printsize=FineDec($size);


  $url=qq(<A href="user_detail.cgi?year=$year&month=$month&day=$day&user=$user">$user</A>);
  $url =~ s/#/%23/;

  $timeurl=qq(<A href="user_time.cgi?year=$year&month=$month&day=$day&user=$user">##MSG_TIME_LINK##</A>);

  $tmp=$hTPL{user};
  $tmp=~s/##USERNUM##/$N/;
  $tmp=~s/##TIMEURL##/$timeurl/;
  $tmp=~s/##USERURL##/$url/;
  $tmp=~s/##USERCONNECT##/$printhit/;
  $tmp=~s/##USERBYTES##/$printsize/;
  $tmp=~s/##USERPERCENT##/$percent/;
  $tpl{user} .= $tmp;

}

ReplaceTPL(TOPSITESURL,$topsites);
ReplaceTPL(BIGFILESURL,$bigfiles);
ReplaceTPL(DATE,$workperiod);
ReplaceTPL(OVERMSG,$overmsg);

ApplyTPL();
HideTPL("timereport") if ($timereport == 0);
print $template;

__END__
2004-12-18 ADD :       
2005-04-14 ADD : usertrafficlimit support
2005-04-17 ADD : TemplateEngine
2005-05-01 ADD : Time Report Support
