#!/usr/bin/perl
#
# LightSquid Project (c) 2004-2005 Sergey Erokhin aka ESL
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# detail see in gnugpl.txt

print "Content-Type: text/html\n\n";

use File::Basename;
push (@INC,(fileparse($0))[1]);

use CGI;
require "lightsquid.cfg";
require "common.pl";

InitTPL("user_time");

$co=new CGI;

$year =$co->param('year');
$month=$co->param('month');
$day  =$co->param('day');
$user =$co->param('user');
$mode =$co->param('mode');

if      ($mode eq "month") {
  $workperiod="##MSG_WHOLE## ##MSG_MONTH## - $year $MonthName[$month]";
  $mask = "$year$month";
} elsif ($mode eq "year") {
  $workperiod="##MSG_WHOLE## ##MSG_YEAR## - $year";
  $mask = "$year";
} else {
  $workperiod="$day $MonthName[$month] $year";
  $mask = "$year$month$day";
}

@datelist=sort glob "$reportpath/$mask*";

$calculatedtotal=0;
foreach $workday (sort @datelist) {
  open FF,"<$workday/$user" || die "can't open $daypath/$user";
  $totalsize=<FF>;chomp $totalsize;$totalsize=~s/total: //;

#  print "<table border=1>";
  while (<FF>) {
    ($site,$size,$hit,@hlog)=split;
    $h{$site}{hit} +=$hit;
    $h{$site}{size}+=$size;
    $calculatedtotal+=$size;

#    print "<tr>";
#    map {print "<td>$_</td>"} @hlog;
#    print "</tr>";

    for ($h=0;$h<24;$h++) {
      ($ttime,$tsize)=split /-/,$hlog[$h];
      $hsitetime{$site}[$h]+=$tsize;
      $htime[$h]+=$ttime;
      $hsize[$h]+=$tsize;
    }

  }  
#  print "</table>";
  close FF;
}

$tmp=$hTPL{site};
$tmp=~s/##URL##/##MSG_TOTAL##/;
$tmp=~s/##NUM##//;
$HH="00";
$total=0;
for ($h=0;$h<24;$h++) {
  $size = sprintf("%.1f",$hsize[$h]/(1024*1024));
  $size = "." if (0 == $hsize[$h]);
  $total+=$hsize[$h];
  $tmp=~s/##T$HH##/$size/;
  $HH++;
}    
$printsize =FineDec($total);
$tmp=~s/##URLSIZE##/$printsize/;
$tpl{site} .= $tmp;


$N=0;
$total=0;

foreach $site (sort {$h{$b}{size} <=> $h{$a}{size}} keys %h)  {
  $N++;
  $HH="00";
  $size=$h{$site}{size};
  
  next if ($N > $usertimelimit);
  
  $printsize =FineDec($size);
  
  $tmp=$hTPL{site};
  $tmp=~s/##URL##/$site/;
  for ($h=0;$h<24;$h++) {
    $size = sprintf("%.1f",$hsitetime{$site}[$h]/(1024*1024));
    $size = "." if (0 == $hsitetime{$site}[$h]);
    $tmp=~s/##T$HH##/$size/;
    $HH++;
  }    
  $tmp=~s/##NUM##/$N/;
  $tmp=~s/##URLSIZE##/$printsize/;
  $tpl{site} .= $tmp;

}

if ($N > $usertimelimit) {
  $HH="00";
  $tmp=$hTPL{site};
  $tmp=~s/##URL##/\.\.\./;
  $ttt="...";
  for ($h=0;$h<24;$h++) {
    $tmp=~s/##T$HH##/$ttt/;
    $HH++;
  }    
  $tmp=~s/##NUM##/\.\.\./;
  $tmp=~s/##URLSIZE##/\.\.\./;
  $tpl{site} .= $tmp;

  $printsize =FineDec($size);
  $HH="00";
  $tmp=$hTPL{site};
  $tmp=~s/##URL##/$site/;
  for ($h=0;$h<24;$h++) {
    $size = sprintf("%.1f",$hsitetime{$site}[$h]/(1024*1024));
    $size = "." if (0 == $hsitetime{$site}[$h]);
    $tmp=~s/##T$HH##/$size/;
    $HH++;
  }    
  $tmp=~s/##NUM##/$N/;
  $tmp=~s/##URLSIZE##/$printsize/;
  $tpl{site} .= $tmp;
}

$printtotalsize=FineDec($calculatedtotal);
	      
ReplaceTPL(USER,$user);
ReplaceTPL(WORKPERIOD,$workperiod);
      
ApplyTPL();
print $template;
	      

__END__
2005-05-01 ADD : Initial release
